blob: d46b7d43602707f89b1582d8c3b746b98fb9207f [file] [log] [blame]
garciadeblas93c61312016-09-28 15:12:48 +02001#!/bin/bash
garciadeblas38d91ee2019-11-07 16:31:23 +01002#
3# Licensed under the Apache License, Version 2.0 (the "License");
4# you may not use this file except in compliance with the License.
5# You may obtain a copy of the License at
6#
7# http://www.apache.org/licenses/LICENSE-2.0
8#
9# Unless required by applicable law or agreed to in writing, software
10# distributed under the License is distributed on an "AS IS" BASIS,
11# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
12# See the License for the specific language governing permissions and
13# limitations under the License.
14#
garciadeblasd8bc5c32018-05-09 17:37:56 +020015REPOSITORY_BASE=https://osm-download.etsi.org/repository/osm/debian
garciadeblasf407c452024-08-22 14:23:40 +020016RELEASE=ReleaseSIXTEEN
garciadeblas7bcadc52020-02-02 22:40:15 +010017REPOSITORY=stable
garciadeblas931a5122023-10-03 17:52:02 +020018DOCKER_TAG="testing-daily"
garciadeblas2bf767a2021-05-19 10:54:46 +020019DEVOPS_PATH=/usr/share/osm-devops
garciadeblas93c61312016-09-28 15:12:48 +020020
garciadeblas38d91ee2019-11-07 16:31:23 +010021function usage(){
22 echo -e "usage: $0 [OPTIONS]"
garciadeblas81077ae2023-07-03 19:31:15 +020023 echo -e "Install OSM"
garciadeblas38d91ee2019-11-07 16:31:23 +010024 echo -e " OPTIONS"
garciadeblas7f1e1042020-11-30 14:07:03 +000025 echo -e " -h / --help: print this help"
26 echo -e " -y: do not prompt for confirmation, assumes yes"
garciadeblas38d91ee2019-11-07 16:31:23 +010027 echo -e " -r <repo>: use specified repository name for osm packages"
khelifibca83312025-06-17 16:06:23 +020028 echo -e " -R <release>: use specified release for osm binaries (deb packages, ...)"
garciadeblas38d91ee2019-11-07 16:31:23 +010029 echo -e " -u <repo base>: use specified repository url for osm packages"
30 echo -e " -k <repo key>: use specified repository public key url"
garciadeblas96155042022-06-22 16:26:22 +020031 echo -e " -a <apt proxy url>: use this apt proxy url when downloading apt packages (air-gapped installation)"
garciadeblas8d8cd992024-05-21 16:04:14 +020032 echo -e " -c <kubernetes engine>: use a specific kubernetes engine (options: kubeadm, k3s), default is kubeadm"
33 echo -e " -t <docker tag> specify osm docker tag (default is latest)"
34 echo -e " -M <KUBECONFIG_FILE>: Kubeconfig of an existing cluster to be used as mgmt cluster instead of OSM cluster"
35 echo -e " -G <KUBECONFIG_FILE>: Kubeconfig of an existing cluster to be used as auxiliary cluster instead of OSM cluster"
36 echo -e " --no-mgmt-cluster: Do not provision a mgmt cluster for cloud-native gitops operations in OSM (NEW in Release SIXTEEN) (by default, it is installed)"
37 echo -e " --no-aux-cluster: Do not provision an auxiliary cluster for cloud-native gitops operations in OSM (NEW in Release SIXTEEN) (by default, it is installed)"
38 echo -e " -D <devops path>: use local devops installation path"
garciadeblas81077ae2023-07-03 19:31:15 +020039 echo -e " -s <namespace> namespace when installed using k8s, default is osm"
garciadeblas8d8cd992024-05-21 16:04:14 +020040 echo -e " -w <work dir>: Location to store runtime installation"
David Garcia404ae122020-04-28 11:47:55 +020041 echo -e " -K: Specifies the name of the controller to use - The controller must be already bootstrapped"
garciadeblas7f1e1042020-11-30 14:07:03 +000042 echo -e " -d <docker registry URL> use docker registry URL instead of dockerhub"
43 echo -e " -p <docker proxy URL> set docker proxy URL as part of docker CE configuration"
garciadeblas9a510862021-04-21 14:15:56 +020044 echo -e " -T <docker tag> specify docker tag for the modules specified with option -m"
garciadeblas96155042022-06-22 16:26:22 +020045 echo -e " --debug: debug mode"
garciadeblas38d91ee2019-11-07 16:31:23 +010046 echo -e " --nodocker: do not install docker, do not initialize a swarm (assumes docker is already installed and a swarm has been initialized)"
garciadeblas38d91ee2019-11-07 16:31:23 +010047 echo -e " --nohostclient: do not install the osmclient"
48 echo -e " --uninstall: uninstall OSM: remove the containers and delete NAT rules"
garciadeblascb129372020-11-14 23:06:42 +000049 echo -e " --k8s_monitor: install the OSM kubernetes monitoring with prometheus and grafana"
garciadeblas38d91ee2019-11-07 16:31:23 +010050 echo -e " --showopts: print chosen options and exit (only for debugging)"
garciadeblas38d91ee2019-11-07 16:31:23 +010051}
52
garciadeblasd8bc5c32018-05-09 17:37:56 +020053add_repo() {
54 REPO_CHECK="^$1"
55 grep "${REPO_CHECK/\[arch=amd64\]/\\[arch=amd64\\]}" /etc/apt/sources.list > /dev/null 2>&1
56 if [ $? -ne 0 ]
57 then
garciadeblasbd925e42018-06-14 14:32:12 +020058 need_packages_lw="software-properties-common apt-transport-https"
garciadeblas0bc87522021-10-20 22:16:17 +020059 echo -e "Checking required packages to add ETSI OSM debian repo: $need_packages_lw"
garciadeblasbd925e42018-06-14 14:32:12 +020060 dpkg -l $need_packages_lw &>/dev/null \
61 || ! echo -e "One or several required packages are not installed. Updating apt cache requires root privileges." \
garciadeblas5f420b12022-02-10 01:43:59 +010062 || sudo apt-get -qy update \
Mike Marchetti34124182018-10-16 08:22:30 -040063 || ! echo "failed to run apt-get update" \
garciadeblasbd925e42018-06-14 14:32:12 +020064 || exit 1
65 dpkg -l $need_packages_lw &>/dev/null \
66 || ! echo -e "Installing $need_packages_lw requires root privileges." \
67 || sudo apt-get install -y $need_packages_lw \
Mike Marchetti34124182018-10-16 08:22:30 -040068 || ! echo "failed to install $need_packages_lw" \
garciadeblasbd925e42018-06-14 14:32:12 +020069 || exit 1
garciadeblasbc97a012022-04-21 00:29:02 +020070 wget -q -O OSM-ETSI-Release-key.gpg "$REPOSITORY_BASE/$RELEASE/OSM%20ETSI%20Release%20Key.gpg"
71 sudo APT_KEY_DONT_WARN_ON_DANGEROUS_USAGE=1 apt-key add OSM-ETSI-Release-key.gpg \
72 || ! echo -e "Could not add GPG key $REPOSITORY_BASE/$RELEASE/OSM%20ETSI%20Release%20Key.gpg" \
73 || exit 1
garciadeblas5f420b12022-02-10 01:43:59 +010074 sudo DEBIAN_FRONTEND=noninteractive add-apt-repository -y "$1"
garciadeblasbc97a012022-04-21 00:29:02 +020075 sudo DEBIAN_FRONTEND=noninteractive apt-get -y update
garciadeblas429b9f82018-03-20 02:09:44 +010076 return 0
garciadeblasd8bc5c32018-05-09 17:37:56 +020077 fi
78
79 return 1
garciadeblas55490d42016-10-29 14:22:03 +020080}
81
garciadeblas25e87d22020-01-31 14:27:29 +010082clean_old_repo() {
madaviae0784f2020-01-22 16:29:19 +053083dpkg -s 'osm-devops' &> /dev/null
madaviae0784f2020-01-22 16:29:19 +053084if [ $? -eq 0 ]; then
madaviae0784f2020-01-22 16:29:19 +053085 # Clean the previous repos that might exist
86 sudo sed -i "/osm-download.etsi.org/d" /etc/apt/sources.list
87fi
88}
89
garciadeblas0bc87522021-10-20 22:16:17 +020090function configure_apt_proxy() {
91 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
92 OSM_APT_PROXY=$1
93 OSM_APT_PROXY_FILE="/etc/apt/apt.conf.d/osm-apt"
94 echo "Configuring apt proxy in file ${OSM_APT_PROXY_FILE}"
95 if [ ! -f ${OSM_APT_PROXY_FILE} ]; then
96 sudo bash -c "cat <<EOF > ${OSM_APT_PROXY}
97Acquire::http { Proxy \"${OSM_APT_PROXY}\"; }
98EOF"
99 else
100 sudo sed -i "s|Proxy.*|Proxy \"${OSM_APT_PROXY}\"; }|" ${OSM_APT_PROXY_FILE}
101 fi
garciadeblas5f420b12022-02-10 01:43:59 +0100102 sudo apt-get -y update || FATAL "Configured apt proxy, but couldn't run 'apt-get update'. Check ${OSM_APT_PROXY_FILE}"
garciadeblas0bc87522021-10-20 22:16:17 +0200103 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
104}
105
khelifibca83312025-06-17 16:06:23 +0200106while getopts ":a:c:e:r:n:k:u:R:D:o:O:N:s:t:U:l:L:K:d:p:T:f:F:G:M:-: hy" o; do
garciadeblas8d8cd992024-05-21 16:04:14 +0200107
garciadeblas38d91ee2019-11-07 16:31:23 +0100108 case "${o}" in
Antonio Marsico75a38c72020-12-21 17:29:42 +0100109 D)
110 DEVOPS_PATH="${OPTARG}"
111 ;;
garciadeblas38d91ee2019-11-07 16:31:23 +0100112 r)
113 REPOSITORY="${OPTARG}"
114 ;;
115 R)
116 RELEASE="${OPTARG}"
117 ;;
118 u)
119 REPOSITORY_BASE="${OPTARG}"
120 ;;
121 t)
garciadeblas25e87d22020-01-31 14:27:29 +0100122 DOCKER_TAG="${OPTARG}"
garciadeblas38d91ee2019-11-07 16:31:23 +0100123 ;;
garciadeblas72399e32019-11-22 10:09:40 +0100124 -)
125 [ "${OPTARG}" == "help" ] && usage && exit 0
Dominik Fleischmann5e4a7512020-03-06 14:05:06 +0100126 ;;
garciadeblas25e87d22020-01-31 14:27:29 +0100127 :)
128 echo "Option -$OPTARG requires an argument" >&2
129 usage && exit 1
130 ;;
131 \?)
132 echo -e "Invalid option: '-$OPTARG'\n" >&2
133 usage && exit 1
134 ;;
135 h)
136 usage && exit 0
137 ;;
garciadeblas38d91ee2019-11-07 16:31:23 +0100138 *)
139 ;;
140 esac
141done
142
garciadeblas25e87d22020-01-31 14:27:29 +0100143clean_old_repo
garciadeblasd8bc5c32018-05-09 17:37:56 +0200144add_repo "deb [arch=amd64] $REPOSITORY_BASE/$RELEASE $REPOSITORY devops"
garciadeblas5f420b12022-02-10 01:43:59 +0100145sudo DEBIAN_FRONTEND=noninteractive apt-get -qy update
146sudo DEBIAN_FRONTEND=noninteractive apt-get -y install osm-devops
Antonio Marsico75a38c72020-12-21 17:29:42 +0100147$DEVOPS_PATH/installers/full_install_osm.sh -R $RELEASE -r $REPOSITORY -u $REPOSITORY_BASE -D $DEVOPS_PATH -t $DOCKER_TAG "$@"